'37_in_1, KY-001, Temperature Sensor Module (DS18B20)

$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 20
$swstack = 20
$framesize = 80

Dim Ds1820_adr(8) As Byte , I As Byte
Dim Temp_s As Single
Dim Cmd As Byte

'Config Base = 1
Config Clockdiv = 1

$include "Arduino_pins.sub"                                 'include Arduino pin definitions
$include "DS18B20$SE.sub"                                   'include DS18B20$SE.sub

Config Arduino_pin#2 = Input
Arduino_port#2 = 1

Config 1wire = Arduino_port#7

Wait 1
Print "37_in_1 demo program 9"
Print "#2 = digital input"
Print "#7 = 1-wire"
Print

Do
  While Arduino_pin#2 = 0
    Gosub Ds18b20_measure_temp
    Waitms 750
  Wend
  Cmd = Inkey()
  If Cmd = 0 Then
  Elseif Cmd = "1" Then
    Gosub Ds18b20_measure_temp
  Elseif Cmd = "2" Then
    Gosub Ds18b20_read_address
  Elseif Cmd = "3" Then
    Gosub Ds18b20_measure_temp_a
  Else
    Print "??"
  End If
Loop

End

Ds18b20_read_address:
  Print "Addr = ";
  Ds18b20$read_address Ds1820_adr(_base)
  If Err = 1 Then
    Print "DS1820?"
  Else
#if _base = 0
    For I = 0 To 7
      Print Hex(ds1820_adr(i)) ;
    Next
#endif
#if _base = 1
    For I = 1 To 8
      Print Hex(ds1820_adr(i)) ;
    Next
#endif
    Print
  End If
Return

Ds18b20_measure_temp:
  Print "Temp = ";
  Ds18b20$measure_temp
  If Err = 0 Then
    Waitms 800
    Ds18b20$read_temp
  End If
  If Err = 0 Then
    Temp_s = Ds18b20$temp / 16
    Print Fusing(temp_s , "#.#") ; "C"
  Else
    Print "DS1820?"
  End If
Return

Ds18b20_measure_temp_a:
  Print "Addr = ";
#if _base = 0
  For I = 0 To 7
    Print Hex(ds1820_adr(i)) ;
  Next
  Print
  Print "Temp = ";
  Ds18b20$measure_temp_a Ds1820_adr(0)
  If Err = 0 Then
    Waitms 800
    Ds18b20$read_temp_a Ds1820_adr(0)
  End If
#endif
#if _base = 1
  For I = 1 To 8
    Print Hex(ds1820_adr(i)) ;
  Next
  Print
  Print "Temp = ";
  Ds18b20$measure_temp_a Ds1820_adr(1)
  If Err = 0 Then
    Waitms 800
    Ds18b20$read_temp_a Ds1820_adr(1)
  End If
#endif

  If Err = 0 Then
    Temp_s = Ds18b20$temp / 16
    Print Fusing(temp_s , "#.#") ; "C"
  Else
    Print "DS1820?"
  End If
Return